
Redmine - Defect #13544

Commit reference: autogenerated issue note has wrong commit link syntax in multi-repo or

cross-project context

2013-03-21 13:40 - Dietmar H

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version: 2.4.3   

Resolution: Fixed Affected version: 2.2.3

Description

Redmine 2.2.3, multi project, multi repo per project.

If I do:

git commit -am "bla... refs #123456"

open issue #123456 in browser. The added note reads:

Applied in changeset somerepo|commit:aa101cb4a8

In order to become a link, it should be

Applied in changeset commit:somerepo|aa101cb4a8

instead.    

For cross project links, the generated note is:

Applied in changeset someproj:somerepo|commit:aa101cb4a8

should be

Applied in changeset someproj:commit:somerepo|commit:aa101cb4a8

Related issues:

Related to Redmine - Patch #14476: Fix for Issue #13544 Closed

Has duplicate Redmine - Defect #16017: fixing keywords failed to link to repo... Closed

Has duplicate Redmine - Defect #14405: Alternate repo commit: link wrong when... Closed

Has duplicate Redmine - Defect #12685: Commit message generates invalid link ... Closed

Has duplicate Redmine - Defect #13036: auto generated comment "Applied in cha... Closed

Associated revisions

Revision 12660 - 2014-01-12 10:19 - Jean-Philippe Lang

Fixed Changeset#text_tag for changeset with hash and repository identifier (#13544).

Revision 12845 - 2014-02-06 18:58 - Jean-Philippe Lang

Merged r12660 (#13544).

History

#1 - 2013-07-04 13:02 - Omar Kohl

- File 13544.patch added
+1

I can confirm this on version 2.3.1. Attached is a patch that fixes the issue.

#2 - 2013-07-17 14:09 - Jan Niggemann (redmine.org team member)

- Related to Patch #14476: Fix for Issue #13544 added

#3 - 2013-09-19 10:16 - Omar Kohl

This issue is still open in 2.3.3.

The correct syntax for commit links is as follows: (see http://www.redmine.org/help/wiki_syntax_detailed.html)

Changesets:

r758 (link to a changeset)

commit:c6f4d0fd (link to a changeset with a non-numeric hash)

svn1|r758 (link to a changeset of a specific repository, for projects with multiple repositories)

commit:hg|c6f4d0fd (link to a changeset with a non-numeric hash of a specific repository)

sandbox:r758 (link to a changeset of another project)

sandbox:commit:c6f4d0fd (link to a changeset with a non-numeric hash of another project)

The current code in app/models/changeset.rb generates links such as:

hg|commit:c6f4d0fd instead of commit:hg|c6f4d0fd

# Current Code

def text_tag(ref_project=nil)

  tag = if scmid?

    "commit:#{scmid}" 

  else

    "r#{revision}" 

  end

  if repository && repository.identifier.present?

    tag = "#{repository.identifier}|#{tag}" 

  end

  if ref_project && project && ref_project != project

    tag = "#{project.identifier}:#{tag}" 

  end

  tag

end

 My fix:

diff --git a/app/models/changeset.rb b/app/models/changeset.rb

index d3fa8ab..1951703 100644

--- a/app/models/changeset.rb

+++ b/app/models/changeset.rb

@@ -157,7 +157,11 @@ class Changeset < ActiveRecord::Base

       "r#{revision}" 

     end

     if repository && repository.identifier.present?

-      tag = "#{repository.identifier}|#{tag}" 

+      if scmid?

+        tag = "commit:#{repository.identifier}|#{scmid}" 

+      else

+        tag = "#{repository.identifier}|#{tag}" 

+      end

     end

     if ref_project && project && ref_project != project

       tag = "#{project.identifier}:#{tag}" 

 It is a nuisance to fix this every time I update Redmine. Could maybe someone with Commit-Access to Redmine have a look at this?

#4 - 2014-01-12 10:20 - Jean-Philippe Lang

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Target version set to 2.4.3

- Resolution set to Fixed

Fixed in r12660.
#5 - 2014-02-06 18:58 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Merged.

#6 - 2014-03-01 04:23 - Toshi MARUYAMA

- Has duplicate Defect #16017: fixing keywords failed to link to repository with identifier added

#7 - 2014-03-17 06:28 - Toshi MARUYAMA

- Has duplicate Defect #14405: Alternate repo commit: link wrong when automatically added from a commit message added

#8 - 2015-07-13 13:04 - Toshi MARUYAMA

- Has duplicate Defect #12685: Commit message generates invalid link when repository has an identifier added

#9 - 2015-07-13 13:09 - Toshi MARUYAMA

- Has duplicate Defect #13036: auto generated comment "Applied in changeset xxx" is not link to commit added

Files

13544.patch 599 Bytes 2013-07-04 Omar Kohl
